
/*  FastVid.H   version 1.0   May 30, 1987  */
/*                                          */
/*        Written by Scott Friedman         */

#define   NULL      0
#define   YES       1
#define   NO        0
#define   UP        6
#define   DOWN      7
#define   BLACK     0
#define   BLUE      1
#define   GREEN     2
#define   CYAN      3
#define   RED       4
#define   MAGENTA   5
#define   BROWN     6
#define   WHITE     7
#define   BRIGHT    8
#define   BLINK     128

typedef unsigned char byte;
typedef struct {
     char Horiz, Vert,
          UpLeft, UpRight, LoLeft, LoRight,
          TopT, BottomT, LeftT, RightT;
} _F;


void UseBios ( byte YN );
void HaveSnow ( byte YN );
void InitText ( void );
int  EgaInstalled ( void );
void SetCursor ( byte Start, byte End );
void HideCursor ( void );
void ShowCursor ( void );
int  GetVideoMode ( void );
void SetVideoMode ( byte Mode );
int  IsxyOk ( int Col, int Row );
int  Gotoxy ( int Col, int Row );
void GotoxyB ( int Col, int Row );
void Getxy ( int *Col, int *Row );
void GetxyB ( int *Col, int *Row );
byte Attr ( byte Foreground, byte Background );
void SetAttribute ( byte Attribute );
byte GetAttribute ( void );
void FlipAttribute ( byte Attribute, int Number );
void AtFlipAttribute ( int Col, int Row, byte Attribute, int Number );
void SetPage ( byte Page );
byte GetPage ( void );
void SetBorder ( byte Color );
void Scroll ( byte Direction, byte NumOfLines, byte Attribute, int x1, int y1, int x2, int y2 );
void Cls ( byte Attribute );
void Say ( char *Text );
void SayA ( char *Text, byte Attribute );
void AtSay ( int Col, int Row, char *Text );
void AtSayA ( int Col, int Row, char *Text, byte Attribute );
void SayC ( char Character );
void AtSayC ( int Col, int Row, char Character );
void SayCN ( char Character, int Number );
void AtSayCN ( int Col, int Row, char Character, int Number );
void AtSayCNV ( int Col, int Row, char Character, int Number );

