/************************************************************************/
/*                                                                      */
/*  MFLMATH header file                                                 */
/*                                                                      */
/*  Defines and function prototypes for high-speed integer math         */
/*                                                                      */
/*  Copyright 1989 by Robert B. Stout dba MicroFirm                     */
/*  All rights reserved                                                 */
/*                                                                      */
/*  Copyright 1986, 1987 by S.E. Margison                               */
/*                                                                      */
/*  Compiled by QC 2.0 for use with MSC 5.1 or QC 2.0 or later.         */
/*                                                                      */
/************************************************************************/

#ifndef MFL_MATH_H
#define MFL_MATH_H

#include <mfldefs.h>

#ifndef _Cdecl_
 #ifdef NO_EXT_KEYS
  #define _Cdecl_
 #else
  #define _Cdecl_ cdecl
 #endif
#endif

/************************************************************************/
/*                                                                      */
/*  CRC calculation functions                                           */
/*                                                                      */
/************************************************************************/

unsigned        _Cdecl_ crc16_clear(void),
                _Cdecl_ crc16_update(unsigned, unsigned char),
                _Cdecl_ crc16_finish(unsigned);

unsigned long   _Cdecl_ crc32_clear(void),
                _Cdecl_ crc32_update(unsigned long, unsigned char),
                _Cdecl_ crc32_finish(unsigned long);

/************************************************************************/
/*                                                                      */
/*  Integer math functions                                              */
/*                                                                      */
/************************************************************************/

int             _Cdecl_ isqrt(unsigned),
                _Cdecl_ isqrtr(unsigned);

long            _Cdecl_ lsqrt(unsigned long),
                _Cdecl_ lsqrtr(unsigned long);

#endif /* MFL_MATH_H */
