/************************************************************************/
/*                                                                      */
/*  LOCALE Header file                                                  */
/*                                                                      */
/*  Draft ANSI-spec header for country-specific information.            */
/*                                                                      */
/*  Copyright 1989 by Robert B. Stout dba MicroFirm                     */
/*  All rights reserved                                                 */
/*                                                                      */
/*  Compiled by QC 2.0 for use with MSC 5.1 or QC 2.0 or later.         */
/*                                                                      */
/************************************************************************/

#ifndef STDARG_H
#include <stdarg.h>
#endif

#ifndef LOCALE_H
#define LOCALE_H

#define LC_ALL          0
#define LC_COLLATE      1
#define LC_CTYPE        2
#define LC_MONETARY     3
#define LC_NUMERIC      4
#define LC_TIME         5

/************************************************************************/
/*                                                                      */
/*  Set up enumerated data types for locales and date ordering -        */
/*  provide a default locale.                                           */
/*                                                                      */
/************************************************************************/

typedef enum {_C_, USA, MAX_LOC} _locale_loc;

#define LOC_DEFAULT USA

/*
**  ANSI-specified locale definition structure
*/

struct lconv {
                char    *s_all;

                char    *s_collate;

                char    *s_ctype;

                char    *s_monetary;
                char    *currency_symbol;
                char    *int_curr_symbol;
                char    *mon_decimal_point;
                char    *mon_thousands_sep;
                char    *mon_grouping;
                char    *positive_sign;
                char    *negative_sign;
                char    int_frac_digits;
                char    frac_digits;
                char    p_cs_precedes;
                char    n_cs_precedes;
                char    p_sep_by_space;
                char    n_sep_by_space;
                char    p_sign_posn;
                char    n_sign_posn;

                char    *s_numeric;
                char    *decimal_point;
                char    *thousands_sep;
                char    *grouping;

                char    *s_time;
                char    *day[7][2];
                char    *month[12][2];
                int     TZ_secs;
                int     DST_flag;
                char    *TZ_txt[2];
                char    tim_sep;
                char    *p_FMTA;
                char    *p_FMTP;
                char    *c_FORMAT;
                char    *x_FORMAT;
                char    *X_FORMAT;
		char	fmt_24;
        };

/*
**  ANSI-mandated locale-related functions
*/

#ifndef _Cdecl_
 #ifdef NO_EXT_KEYS
  #define _Cdecl_
 #else
  #define _Cdecl_ cdecl
 #endif
#endif

char         * _Cdecl_ setlocale(int, const char *);
struct lconv * _Cdecl_ localeconv(void);

#endif /* LOCALE_H */
