/*******************************************************************************
*        SCL1SND.H - sound define constant for SCL1 Library version 2.0        *
*                                                                              *
*          Copyright (C) 1990 by Jos Rodrguez Alvira & Jos R. Lebrn        *
*******************************************************************************/

/* syntax  TS_X[y]?     

    were:  TS = TSound id
            X = musical note (C,D,E,F,G,A,B)
            y = s means sharp, f means flat (optional)
            ? = octave (1 - 7)

examples:   TS_Df4 = D flat, fourth octave 
             TS_C4 = C, fourth octave (middle C)    */

#define TS_C1   33          /* values in hertz */
#define TS_Cs1  35
#define TS_Df1  35
#define TS_D1   37
#define TS_Ds1  39
#define TS_Ef1  39
#define TS_E1   41
#define TS_F1   44
#define TS_Fs1  46
#define TS_Gf1  46
#define TS_G1   49
#define TS_Gs1  52
#define TS_Af1  52
#define TS_A1   55
#define TS_As1  58
#define TS_Bf1  58
#define TS_B1   62

#define TS_C2   65
#define TS_Cs2  69
#define TS_Df2  69
#define TS_D2   73
#define TS_Ds2  78
#define TS_Ef2  78
#define TS_E2   82
#define TS_F2   87
#define TS_Fs2  93
#define TS_Gf2  93
#define TS_G2   98
#define TS_Gs2  103
#define TS_Af2  103
#define TS_A2   110
#define TS_As2  116
#define TS_Bf2  116
#define TS_B2   123

#define TS_C3   131
#define TS_Cs3  139
#define TS_Df3  139
#define TS_D3   147
#define TS_Ds3  156
#define TS_Ef3  156
#define TS_E3   165
#define TS_F3   175
#define TS_Fs3  185
#define TS_Gf3  185
#define TS_G3   196
#define TS_Gs3  208
#define TS_Af3  208
#define TS_A3   220
#define TS_As3  233
#define TS_Bf3  233
#define TS_B3   247

#define TS_C4   262
#define TS_Cs4  277
#define TS_Df4  277
#define TS_D4   294
#define TS_Ds4  311
#define TS_Ef4  311
#define TS_E4   330
#define TS_F4   349
#define TS_Fs4  370
#define TS_Gf4  370
#define TS_G4   392
#define TS_Gs4  415
#define TS_Af4  415
#define TS_A4   440
#define TS_As4  466
#define TS_Bf4  466
#define TS_B4   494

#define TS_C5   523
#define TS_Cs5  554
#define TS_Df5  554
#define TS_D5   587
#define TS_Ds5  622
#define TS_Ef5  622
#define TS_E5   659
#define TS_F5   698
#define TS_Fs5  740
#define TS_Gf5  740
#define TS_G5   784
#define TS_Gs5  831
#define TS_Af5  831
#define TS_A5   880
#define TS_As5  932
#define TS_Bf5  932
#define TS_B5   988

#define TS_C6   1047
#define TS_Cs6  1109
#define TS_Df6  1109
#define TS_D6   1175
#define TS_Ds6  1245
#define TS_Ef6  1245
#define TS_E6   1329
#define TS_F6   1397
#define TS_Fs6  1480
#define TS_Gf6  1480
#define TS_G6   1568
#define TS_Gs6  1661
#define TS_Af6  1661
#define TS_A6   1760
#define TS_As6  1865
#define TS_Bf6  1865
#define TS_B6   1976

#define TS_C7   2093
#define TS_Cs7  2217
#define TS_Df7  2217
#define TS_D7   2349
#define TS_Ds7  2489
#define TS_Ef7  2489
#define TS_E7   2637
#define TS_F7   2794
#define TS_Fs7  2960
#define TS_Gf7  2960
#define TS_G7   3136
#define TS_Gs7  3322
#define TS_Af7  3322
#define TS_A7   3520
#define TS_As7  3729
#define TS_Bf7  3729
#define TS_B7   3951

#define TS_C8   4186

