//	Written by Chris Sokol

#ifndef TTY_H
#define TTY_H	1

#include "ttyio.h"

class	TTY
{
	uint	baud;
	int	error,
			handle;
	uchar	linctl,
			linstat,
			mdmctl,
			mdmstat;
	int	outlinc: 1,
			outmdmc: 1;
	uint	*rxbuf,
			rxlen,
			*txbuf,
			txlen;

public:
			TTY(char *name, uint rxlen, uint txlen);
			~TTY();

	int	Error();
	int	Opened();

	int	Baud(ulong baud);
	int	Bits(uint bits);
	int	Brk(int on);
	int	Prty(char p);
	int	Stop(uint bits);
	int	XOnOff(int ena);
	int	WaitCTS(int ena);

	int	DTR(int dtr);
	int	RTS(int rts);

	void	FlushCtl();

	int	CTS();
	int	DSR();
	int	RING();
	int	RLSD();

	int	Avail();
	uint	Get();

	int	Put(uchar c);

	int	Done();
};

#endif
